local _G=_G
local me,ns=...
local print=function(...) ns.print(me,...) end
local debug=function(...) ns.debug(me,...) end
if (LibDebug) then LibDebug() end 
debug('Loading AlarCastButton inside')
local AWG=LibStub("AlarWidgets-3.0")
local AceGUI=AWG.AceGUI
local InjectStandardMethods=AWG.InjectStandardMethods
do
	local AWG=AWG
    local Type="AlarCastButtonBase"
    local Version=1
    local Serial =0
    local function AnimationComplete(this)
    	local i=this:GetChange()
    	if (i > 0) then
    		this.obj.frame:Show()
    	else
    		this.obj.frame:Hide()
    	end
    	this.obj.frame:SetAlpha(1)
    	
    end
	local function UpdateCooldown(this)
        local c=this.obj.cooldown
        if (this.obj.type == 'spell') then
	        if (c) then
	        	local start,duration,enable=GetSpellCooldown(this.obj.spell)
	        	debug(this.obj.spell,start,duration,enable)
	        	if (start and duration) then
	        		CooldownFrame_SetTimer(c,start,duration,enable)
			    else
			    	CooldownFrame_SetTimer(c,0,0,false)
			    end
	    	end
    	end
    end
    local mb={}
    function mb:FadeOut(speed,delay)
    	local fade=self.fade
    	local frame=self.frame
    	self.faded=true
    	if (not frame:IsShown() or frame:GetAlpha()==0) then return end
    	delay=delay or 5
    	speed=speed or 25
		fade:SetChange(-1)
		fade:SetStartDelay(delay)
		fade:SetDuration(speed)
		fade:Play()
    end
    function mb:FadeStop()
    	local fade=self.fade
    	fade:Stop()
    end
    function mb:FadeIn(speed,delay)
    	local fade=self.fade
    	local frame=self.frame
    	self.faded=false
    	if (frame:IsShown() and frame:GetAlpha()==1) then return end
    	if (not frame:IsShown()) then
    		frame:SetAlpha(0)
    		frame:Show()
    	end
    	delay=delay or 5
    	speed=speed or 25
    	fade:SetChange(1)
    	fade:SetStartDelay(delay)
    	fade:SetDuration(speed)
    	fade:Play()
    end
	function mb:SetImage(path, ...)
		local image = self.image
		image:SetTexture(path)
		self.frame:SetPushedTexture(path)
		if image:GetTexture() then
			self.imageshown = true
			local n = select('#', ...)
			if n == 4 or n == 8 then
				image:SetTexCoord(...)
			end
		else
			self.imageshown = nil
		end
		return image:GetTexture()
	end	
	function mb:SetSize(size)
		local status = self.status or self.localstatus
		status.size=size
		self.frame:SetHeight(size)
		self.frame:SetWidth(size)
		self.image:SetHeight(size)
		self.image:SetWidth(size)
	end

    function mb:SetAttribute(attribute,valore)
    	   local attributes=self.userdata.attributes
    	   self.frame:SetAttribute(attribute,valore)
    end
    function mb:SetUnit(unit)
        self.unit=unit
        self:SetAttribute("unit",unit)
        if (self.title) then
        	self.title:SetAttribute('unit',unit)
        end
    end
    function mb:SetMacrotext(text,button)
    	local this=self.frame
    	self.type='macrotext'
    	button=button or ''
		this:SetAttribute('type' .. button,'macro')
		this:SetAttribute('macrotext' .. button,text)
    	if (self.title) then
    	   self.title:SetAttribute("type" .. button,'macro')
    	   self.title:SetAttribute("macrotext" .. button,text)
    	end		
    end

	function mb:SetCast(type,spell,rank,button,checkselfcast)
	   self.type=type or "spell"
	   self.spell=spell
	   self.rank=rank or ""
	   button=button or ""
	   local this=self.frame
	   if (not spell) then
	       self:SetImage(nil)
	    else
	       local t
    	   if (self.type == "spell") then
    	       t=GetSpellTexture(self.spell)
    	   elseif (self.type == "macro") then
    	       _,t=GetMacroInfo(self.spell)
    	       self:SetImage(t)
    	   elseif (self.type == "macrotext") then
    	   		t=texture
    	   end
    	   if (not t) then
    	       t="Interface\\Icons\\INV_Misc_QuestionMark"
    	   end
		   self:SetImage(t)
    	   if (button) then  -- minimal binding, only to be used in simple cases
    	       this:SetAttribute("type" .. button,type)
    	       this:SetAttribute(type .. button,spell)
    	       if (self.title) then
    	       	self.title:SetAttribute("type" .. button,type)
    	       	self.title:SetAttribute(type .. button,spell)
    	       end
    	    end
    	   UpdateCooldown(this)
    	end
	end
	function mb:HideOnClick(active)
		local frame=self.frame
		self.hideonclick=active
	end
	function mb:SetSpell(...)
		self:SetCast('spell',...)
	end
	mb.SetIcon=mb.SetImage
    function mb.SetPoint(self,...)
    	if (self.standalone) then
    		self.frame:ClearAllPoints()
    		self.frame:SetPoint(...)
    	end
    end
    function mb:ShowAtMouse()
	    local frame=self.frame
	    local scale=UIParent:GetScale()
	    local x,y=GetCursorPosition()
	    frame:SetPoint("CENTER",UIParent,"BOTTOMLEFT",x/scale + 10/scale,y/scale)
	    self:Show()
    end
    function mb:ShowAtCenter()
	    local frame=self.frame
		frame:ClearAllPoints()
		frame:SetPoint("CENTER",UIParent,"CENTER",offset,0)
		self:Show()
	end
    function mb:Pop(duration,speed)
		local status = self.status or self.localstatus
		local frame = self.frame
    	local offset=AWG:Pop(self,status.size or 32)
		frame:ClearAllPoints()
		frame:SetPoint("CENTER",UIParent,"CENTER",offset,0)
		self:Show()
		print ("Popping",self.spell,duration,speed)
		if (type(duration) == 'number') then
			speed=5
			self:FadeOut()
		end
    end
	function mb:ApplyStatus()
		local status = self.status or self.localstatus
		local frame = self.frame
		if (self.standalone) then
			frame:SetParent(UIParent)
			frame:SetFrameStrata("FULLSCREEN_DIALOG")	
			self:SetSize(status.size or 32)		
			frame:ClearAllPoints()
			if status.top and status.left then
				frame:SetPoint("TOP",UIParent,"BOTTOM",0,status.top)
				frame:SetPoint("LEFT",UIParent,"LEFT",status.left,0)
			else
				frame:SetPoint("CENTER",UIParent,"CENTER")
			end
		end
	end		

    local function CheckRange(this)
        local spellname=this.obj.spell
        local unit=this.unit or "target"
        local icon=this.obj.image
        if (spellname) then
            if (SpellHasRange(spellname)) then
                if (IsSpellInRange(spellname,unit) == 0) then
    				icon:SetVertexColor(1.0, 0.1, 0.1);
    			elseif (IsUsableSpell(spellname)) then
        			icon:SetVertexColor(1.0, 1.0, 1.0);
                else
                    icon:SetVertexColor(0.1,0.1,0.5)
    			end
            end
        end
    end
    local function ConstructorBase()
        Serial=Serial +1
        local name=Type .. "_" .. Version .. "_" .. Serial
        local frame=CreateFrame("CheckButton",name,UIParent,"SecureHandlerStateTemplate,SecureActionButtonTemplate,ActionButtonTemplate")        
        local self={}
        InjectStandardMethods(self)
        for method,implementation in pairs(mb) do
        	self[method]=implementation
        end
        self.frame=frame
        self.faded=false
        frame.obj=self
        frame:RegisterForClicks("AnyUp")
	    frame:SetAttribute("_onstate-hidden",[[
	    	print(self,stateid,newstate)
	        if (newstate==1) then
	            self:Hide()
	        else
	            self:Show()
	        end
	    ]])
	    frame:SetAttribute("_onattributechanged",[[
	    	print("attribute changed",name,value)
	    ]]
	    )
	    frame:SetAttribute("_onstate-visible",[[
	        if (self:GetAttribute("showstates"):match(newstate)) then
	            self:SetAttribute("state-hidden","0")
	        else
	            self:SetAttribute("state-hidden","1")
	        end
	    ]])        
        frame:SetAttribute("useparent-unit", true);
        self.cooldown=_G[name .. "Cooldown"]
        self.image=self.frame:GetNormalTexture()
        --frame:SetScript("OnEnter",OnEnter)
        --frame:SetScript("OnLeave",OnLeave)
        frame:SetScript("PostClick",function(this) 
        		UpdateCooldown(this)
        		this:SetChecked(false)
        		this.obj.fade:Stop()
        		hc=this.obj.hideonclick
        		faded=this.obj.faded
        		if (type(hc)=="number") then
        			this.obj:FadeOut(hc,1)
        		elseif(faded or hc) then
        			this:SetAttribute("state-hidden",1)
        		end
        	end
        )
        frame:SetScript("OnEvent",
            function(this,event)
                if (event == "ACTIONBAR_UPDATE_COOLDOWN") then
                    UpdateCooldown(this)
                end
            end
            )
        frame.rangetimer=0.5
        frame:SetScript("OnUpdate",
            function(this,elapsed)
        		this.rangetimer = this.rangetimer - elapsed;
        		if ( this.rangetimer <= 0 ) then
    			     CheckRange(this)
    			     this.rangetimer=0.5
                end
    		end
    		)
        frame:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN")
		local ag=frame:CreateAnimationGroup()--frame:GetName()..'fade')
		local fade=ag:CreateAnimation('Alpha')
		fade:SetChange(-1)
		fade:SetStartDelay(0)
		fade:SetDuration(0)
		fade:SetScript("OnPlay",function(this) debug("Animation started") end)
		fade:SetScript("OnFinished",AnimationComplete)
		--fade:SetScript("OnUpdate",function(this,elapsed) print( elapsed) end )
		fade.obj=self
		self.fade=fade
		AceGUI:RegisterAsWidget(self)
        return self
    end
	AceGUI:RegisterWidgetType(Type,ConstructorBase,Version)
end
do	
	local Type='AlarCastButton'
	local Version=1
	local Serial=0
	local mx={}
	function mx:OnClose(obj,method)
		if (type(obj)=='function') then
			self.xbutton:SetScript("PostClick",obj)
		elseif (type(obj)=="table" and type(method)=="string") then
			if (type(obj[method])=="function") then
				do
					local func=obj[method]
					local obj=obj
					self.xbutton:SetScript("PostClick",function(...) func(obj,...) end)
				end
			end
		end
			
	end

	local function ConstructorButton()
 		local self=AceGUI:Create('AlarCastButtonBase')
		self.standalone=true
        for method,implementation in pairs(mx) do
        	self[method]=implementation
        end
		local frame=self.frame
	    local fname=frame:GetName() .. "XButton"
	    local b=CreateFrame("Button",fname,frame,"UIPanelCloseButton")
	    b:SetHeight(16)
	    b:SetWidth(16)
	    b:SetPoint("TOPRIGHT",frame,"TOPRIGHT",0,0)
	    b:SetFrameLevel(10)
	    self.xbutton=b
		self:ApplyStatus()
		return self
		
	end
	AceGUI:RegisterWidgetType(Type,ConstructorButton,Version)
	AWG.widgets[Type]=Version    
end
do
	local Type='AlarCastIcon'
	local Version=1
	local Serial=0
	local function SetTitle(self,title)
		title=title or ""
		self.titletext:SetText(title)
	end
	local function SetTitleWidth(self,size)
		local title=self.title
		size=tonumber(size) or 180
		self.title:SetWidth(size)
	end
	local function ConstructorIcon()
		local self=AceGUI:Create('AlarCastButtonBase')
		self.standalone=false
		self:ApplyStatus()
		local frame=self.frame
		frame.obj=self
	    local title=CreateFrame("Button",nil,frame,"SecureActionButtonTemplate")
	    title:EnableMouse(true)
        title:RegisterForClicks("AnyUp")	    
	    title:SetHeight(16)
	    title:SetWidth(200)
	    title:SetPoint("TOPLEFT",frame,"TOPRIGHT",0,0)
	    title:SetPoint("BOTTOMLEFT",frame,"BOTTOMRIGHT",0,0)
		local highlight = title:CreateTexture(nil, "HIGHLIGHT")
		highlight:SetTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight")
		highlight:SetBlendMode("ADD")
		highlight:SetAllPoints(title)	    
        local titletext = title:CreateFontString(nil,"OVERLAY","GameFontNormal")
        titletext:SetAllPoints(title)
        titletext:SetJustifyV("CENTER")
        titletext:SetJustifyH("LEFT")
        self.title=title
	    self.titletext=titletext
	    self.SetTitle=SetTitle
	    self.SetTitleWidth=SetTitleWidth
		return self
	end
	AceGUI:RegisterWidgetType(Type,ConstructorIcon,Version)
	AWG.widgets[Type]=Version    
end



